## utf8proc 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

include (utils.cmake)

disallow_intree_builds()

project (utf8proc C)

# Be sure to also update these in Makefile!
set(SO_MAJOR 1)
set(SO_MINOR 3)
set(SO_PATCH 1)

add_definitions (
  -DUTF8PROC_EXPORTS
)

if (NOT MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2 -std=c99 -pedantic -Wall")
endif ()

add_library (utf8proc
  utf8proc.c
  utf8proc.h
)

set_target_properties (utf8proc PROPERTIES
  POSITION_INDEPENDENT_CODE ON
  VERSION "${SO_MAJOR}.${SO_MINOR}.${SO_PATCH}"
  SOVERSION ${SO_MAJOR}
)

=== Makefile ===
# libutf8proc Makefile

# programs
MAKE=make
AR?=ar
CC?=gcc
INSTALL=install
FIND=find

# compiler settings
CFLAGS ?= -O2
PICFLAG = -fPIC
C99FLAG = -std=c99
WCFLAGS = -Wall -Wmissing-prototypes -pedantic
UCFLAGS = $(CFLAGS) $(PICFLAG) $(C99FLAG) $(WCFLAGS) -DUTF8PROC_EXPORTS

# shared-library version MAJOR.MINOR.PATCH ... this may be *different*
# from the utf8proc version number because it indicates ABI compatibility,
# not API compatibility: MAJOR should be incremented whenever *binary*
# compatibility is broken, even if the API is backward-compatible
# Be sure to also update these in MANIFEST and CMakeLists.txt!
MAJOR=1
MINOR=3
PATCH=1

OS := $(shell uname)
ifeq ($(OS),Darwin) # MacOS X
  SHLIB_EXT = dylib
  SHLIB_VERS_EXT = $(MAJOR).dylib
else # GNU/Linux, at least (Windows should probably use cmake)
  SHLIB_EXT = so
  SHLIB_VERS_EXT = so.$(MAJOR).$(MINOR).$(PATCH)
endif

# installation directories (for 'make install')
prefix=/usr/local
libdir=$(prefix)/lib
includedir=$(prefix)/include

# meta targets

.PHONY: all clean data update manifest install

all: libutf8proc.a libutf8proc.$(SHLIB_EXT)

clean:
	rm -f utf8proc.o libutf8proc.a libutf8proc.$(SHLIB_VERS_EXT) libutf8proc.$(SHLIB_EXT)
ifneq ($(OS),Darwin)
	rm -f libutf8proc.so.$(MAJOR)
endif
	rm -f test/tests.o test/normtest test/graphemetest test/printproperty test/charwidth test/valid test/iterate test/case
	rm -rf MANIFEST.new tmp
	$(MAKE) -C bench clean
	$(MAKE) -C data clean

data: data/utf8proc_data.c.new

update: data/utf8proc_data.c.new
	cp -f data/utf8proc_data.c.new utf8proc_data.c

manifest: MANIFEST.new

# real targets

data/utf8proc_data.c.new: libutf8proc.$(SHLIB_EXT) data/data_generator.rb data/charwidths.jl
	$(MAKE) -C data utf8proc_data.c.new

utf8proc.o: utf8proc.h utf8proc.c utf8proc_data.c
	$(CC) $(UCFLAGS) -c -o utf8proc.o utf8proc.c

libutf8proc.a: utf8proc.o
	rm -f libutf8proc.a
	$(AR) rs libutf8proc.a utf8proc.o

libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH): utf8proc.o
	$(CC) $(LDFLAGS) -shared -o $@ -Wl,-soname -Wl,libutf8proc.so.$(MAJOR) utf8proc.o
	chmod a-x $@

libutf8proc.so: libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH)
	ln -f -s libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH) $@
	ln -f -s libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH) $@.$(MAJOR)

libutf8proc.$(MAJOR).dylib: utf8proc.o
	$(CC) -dynamiclib -o $@ $^ -install_name $(libdir)/$@ -Wl,-compatibility_version -Wl,$(MAJOR) -Wl,-current_version -Wl,$(MAJOR).$(MINOR).$(PATCH)

libutf8proc.dylib: libutf8proc.$(MAJOR).dylib
	ln -f -s libutf8proc.$(MAJOR).dylib $@

install: libutf8proc.a libutf8proc.$(SHLIB_EXT) libutf8proc.$(SHLIB_VERS_EXT)
	mkdir -m 755 -p $(DESTDIR)$(includedir)
	$(INSTALL) -m 644 utf8proc.h $(DESTDIR)$(includedir)
	mkdir -m 755 -p $(DESTDIR)$(libdir)
	$(INSTALL) -m 644 libutf8proc.a $(DESTDIR)$(libdir)
	$(INSTALL) -m 755 libutf8proc.$(SHLIB_VERS_EXT) $(DESTDIR)$(libdir)
	ln -f -s libutf8proc.$(SHLIB_VERS_EXT) $(DESTDIR)$(libdir)/libutf8proc.$(SHLIB_EXT)
ifneq ($(OS),Darwin)
	ln -f -s libutf8proc.$(SHLIB_VERS_EXT) $(DESTDIR)$(libdir)/libutf8proc.so.$(MAJOR)
endif

MANIFEST.new:
	rm -rf tmp
	$(MAKE) install prefix=/usr DESTDIR=$(PWD)/tmp
	$(FIND) tmp/usr -mindepth 1 -type l -printf "%P -> %l\n" -or -type f -printf "%P\n" -or -type d -printf "%P/\n" | LC_ALL=C sort > $@
	rm -rf tmp

# Test programs

data/NormalizationTest.txt:
	$(MAKE) -C data NormalizationTest.txt

data/GraphemeBreakTest.txt:
	$(MAKE) -C data GraphemeBreakTest.txt

test/tests.o: test/tests.c test/tests.h utf8proc.h
	$(CC) $(UCFLAGS) -c -o test/tests.o test/tests.c

test/normtest: test/normtest.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) test/normtest.c test/tests.o utf8proc.o -o $@

test/graphemetest: test/graphemetest.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) test/graphemetest.c test/tests.o utf8proc.o -o $@

test/printproperty: test/printproperty.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) test/printproperty.c test/tests.o utf8proc.o -o $@

test/charwidth: test/charwidth.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) test/charwidth.c test/tests.o utf8proc.o -o $@

test/valid: test/valid.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) test/valid.c test/tests.o utf8proc.o -o $@

test/iterate: test/iterate.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) test/iterate.c test/tests.o utf8proc.o -o $@

test/case: test/case.c test/tests.o utf8proc.o utf8proc.h test/tests.h
	$(CC) $(UCFLAGS) test/case.c test/tests.o utf8proc.o -o $@

check: test/normtest data/NormalizationTest.txt test/graphemetest data/GraphemeBreakTest.txt test/printproperty test/case test/charwidth test/valid test/iterate bench/bench.c bench/util.c bench/util.h utf8proc.o
	$(MAKE) -C bench
	test/normtest data/NormalizationTest.txt
	test/graphemetest data/GraphemeBreakTest.txt
	test/charwidth
	test/valid
	test/iterate
	test/case

=== data/Makefile ===
# Unicode data generation rules.  Except for the test data files, most
# users will not use these Makefile rules, which are primarily to re-generate
# unicode_data.c when we get a new Unicode version or charwidth data; they
# require ruby, fontforge, and julia to be installed.

# programs
CURL=curl
RUBY=ruby
PERL=perl
MAKE=make
JULIA=julia
FONTFORGE=fontforge
CURLFLAGS = --retry 5 --location

.PHONY: clean

.DELETE_ON_ERROR:

utf8proc_data.c.new: data_generator.rb UnicodeData.txt GraphemeBreakProperty.txt DerivedCoreProperties.txt CompositionExclusions.txt CaseFolding.txt CharWidths.txt
	$(RUBY) data_generator.rb < UnicodeData.txt > $@

# GNU Unifont version for font metric calculations:
UNIFONT_VERSION=8.0.01

unifont.ttf:
	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://mirrors.kernel.org/gnu/unifont/unifont-$(UNIFONT_VERSION)/unifont-$(UNIFONT_VERSION).ttf

unifont_upper.ttf:
	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://mirrors.kernel.org/gnu/unifont/unifont-$(UNIFONT_VERSION)/unifont_upper-$(UNIFONT_VERSION).ttf

%.sfd: %.ttf
	$(FONTFORGE) -lang=ff -c "Open(\"$<\");Save(\"$@\");Quit(0);"

CharWidths.txt: charwidths.jl unifont.sfd unifont_upper.sfd EastAsianWidth.txt
	$(JULIA) charwidths.jl > $@

UnicodeData.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/UNIDATA/UnicodeData.txt

EastAsianWidth.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/UNIDATA/EastAsianWidth.txt

GraphemeBreakProperty.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/UCD/latest/ucd/auxiliary/GraphemeBreakProperty.txt

DerivedCoreProperties.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/UNIDATA/DerivedCoreProperties.txt

CompositionExclusions.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/UNIDATA/CompositionExclusions.txt

CaseFolding.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/UNIDATA/CaseFolding.txt

NormalizationTest.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/UNIDATA/NormalizationTest.txt

GraphemeBreakTest.txt:
	$(CURL) $(CURLFLAGS) $(URLCACHE)http://www.unicode.org/Public/UCD/latest/ucd/auxiliary/GraphemeBreakTest.txt | $(PERL) -pe 's,÷,/,g;s,×,+,g' > $@

clean:
	rm -f UnicodeData.txt EastAsianWidth.txt GraphemeBreakProperty.txt DerivedCoreProperties.txt CompositionExclusions.txt CaseFolding.txt NormalizationTest.txt GraphemeBreakTest.txt CharWidths.txt unifont*.ttf unifont*.sfd
	rm -f utf8proc_data.c.new

=== debian/changelog ===
utf8proc (1.3.1-2) unstable; urgency=medium

  * Relax build-depends version for unicode-data.

 -- Peter Colberg <peter@colberg.org>  Fri, 06 Nov 2015 13:26:14 -0500

utf8proc (1.3.1-1) unstable; urgency=medium

  * Initial release. (Closes: #803681)

 -- Peter Colberg <peter@colberg.org>  Sun, 01 Nov 2015 13:30:40 -0500

=== debian/control ===
Source: utf8proc
Priority: optional
Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
Uploaders: Peter Colberg <peter@colberg.org>, Graham Inggs <ginggs@debian.org>
Build-Depends: debhelper (>= 9), unicode-data (>= 6.1.0), perl
Standards-Version: 3.9.6
Section: libs
Homepage: http://julialang.org/utf8proc/
Vcs-Git: git://anonscm.debian.org/pkg-julia/utf8proc.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-julia/utf8proc.git

Package: libutf8proc1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C library for processing UTF-8 Unicode data (shared library)
 utf8proc is a small, clean C library that provides Unicode normalization,
 case-folding, and other operations for data in the UTF-8 encoding, supporting
 Unicode version 8.0.
 .
 This package contains a shared version of the library.

Package: libutf8proc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libutf8proc1 (= ${binary:Version})
Description: C library for processing UTF-8 Unicode data (development files)
 utf8proc is a small, clean C library that provides Unicode normalization,
 case-folding, and other operations for data in the UTF-8 encoding, supporting
 Unicode version 8.0.
 .
 This package contains the development files needed to compile software using
 utf8proc.

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/utf8proc-$1\.tar\.gz/ \
https://github.com/JuliaLang/utf8proc/tags .*/v?(\d\S*)\.tar\.gz

## utf8proc 2.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,8 +7,8 @@
 project (utf8proc C)
 
 # Be sure to also update these in Makefile!
-set(SO_MAJOR 1)
-set(SO_MINOR 3)
+set(SO_MAJOR 2)
+set(SO_MINOR 0)
 set(SO_PATCH 1)
 
 add_definitions (

=== Makefile ===
--- 
+++ 
@@ -19,8 +19,8 @@
 # not API compatibility: MAJOR should be incremented whenever *binary*
 # compatibility is broken, even if the API is backward-compatible
 # Be sure to also update these in MANIFEST and CMakeLists.txt!
-MAJOR=1
-MINOR=3
+MAJOR=2
+MINOR=0
 PATCH=1
 
 OS := $(shell uname)

=== debian/changelog ===
utf8proc (2.0.1-1) unstable; urgency=medium

  * New upstream release (Closes: #829236)
  * Refresh patch
  * Bump SONAME to libutf8proc2
  * Update debian/libutf8proc2.symbols
  * Update Vcs-* fields to use https
  * Enable bindnow hardening flag
  * Bump Standards-Version to 3.9.8
  * Add debian/gbp.conf for pristine-tar
  * Build depend on unicode-data >= 9.0 and << 9.1 for tests

 -- Peter Colberg <peter@colberg.org>  Sat, 16 Jul 2016 17:15:58 -0400

## utf8proc 2.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,10 +6,12 @@
 
 project (utf8proc C)
 
-# Be sure to also update these in Makefile!
+# This is the ABI version number, which may differ from the
+# API version number (defined in utf8proc.h).
+# Be sure to also update these in Makefile and MANIFEST!
 set(SO_MAJOR 2)
 set(SO_MINOR 0)
-set(SO_PATCH 1)
+set(SO_PATCH 2)
 
 add_definitions (
   -DUTF8PROC_EXPORTS

=== Makefile ===
--- 
+++ 
@@ -11,17 +11,18 @@
 CFLAGS ?= -O2
 PICFLAG = -fPIC
 C99FLAG = -std=c99
-WCFLAGS = -Wall -Wmissing-prototypes -pedantic
+WCFLAGS = -Wall -pedantic
 UCFLAGS = $(CFLAGS) $(PICFLAG) $(C99FLAG) $(WCFLAGS) -DUTF8PROC_EXPORTS
 
 # shared-library version MAJOR.MINOR.PATCH ... this may be *different*
 # from the utf8proc version number because it indicates ABI compatibility,
 # not API compatibility: MAJOR should be incremented whenever *binary*
-# compatibility is broken, even if the API is backward-compatible
-# Be sure to also update these in MANIFEST and CMakeLists.txt!
+# compatibility is broken, even if the API is backward-compatible.
+# The API version number is defined in utf8proc.h.
+# Be sure to also update these ABI versions in MANIFEST and CMakeLists.txt!
 MAJOR=2
 MINOR=0
-PATCH=1
+PATCH=2
 
 OS := $(shell uname)
 ifeq ($(OS),Darwin) # MacOS X

=== data/Makefile ===
# Unicode data generation rules.  Except for the test data files, most
# users will not use these Makefile rules, which are primarily to re-generate
# unicode_data.c when we get a new Unicode version or charwidth data; they
# require ruby, fontforge, and julia to be installed.

# programs
CURL=curl
RUBY=ruby
PERL=perl
MAKE=make
JULIA=julia
FONTFORGE=fontforge
CURLFLAGS = --retry 5 --location

.PHONY: clean

.DELETE_ON_ERROR:

utf8proc_data.c.new: data_generator.rb UnicodeData.txt GraphemeBreakProperty.txt DerivedCoreProperties.txt CompositionExclusions.txt CaseFolding.txt CharWidths.txt
	$(RUBY) data_generator.rb < UnicodeData.txt > $@

# GNU Unifont version for font metric calculations:
UNIFONT_VERSION=9.0.01

unifont.ttf:
	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://mirrors.kernel.org/gnu/unifont/unifont-$(UNIFONT_VERSION)/unifont-$(UNIFONT_VERSION).ttf

unifont_upper.ttf:
	$(CURL) $(CURLFLAGS) -o $@ $(URLCACHE)https://mirrors.kernel.org/gnu/unifont/unifont-$(UNIFONT_VERSION)/unifont_upper-$(UNIFONT_VERSION).ttf

%.sfd: %.ttf
	$(FONTFORGE) -lang=ff -c "Open(\"$<\");Save(\"$@\");Quit(0);"

CharWidths.txt: charwidths.jl unifont.sfd unifont_upper.sfd EastAsianWidth.txt
	$(JULIA) charwidths.jl > $@

# Unicode data version
UNICODE_VERSION=9.0.0

UnicodeData.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/UnicodeData.txt

EastAsianWidth.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/EastAsianWidth.txt

GraphemeBreakProperty.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/auxiliary/GraphemeBreakProperty.txt

DerivedCoreProperties.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/DerivedCoreProperties.txt

CompositionExclusions.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/CompositionExclusions.txt

CaseFolding.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/CaseFolding.txt

NormalizationTest.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/NormalizationTest.txt

GraphemeBreakTest.txt:
	$(CURL) $(CURLFLAGS) $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/auxiliary/GraphemeBreakTest.txt | $(PERL) -pe 's,÷,/,g;s,×,+,g' > $@

clean:
	rm -f UnicodeData.txt EastAsianWidth.txt GraphemeBreakProperty.txt DerivedCoreProperties.txt CompositionExclusions.txt CaseFolding.txt NormalizationTest.txt GraphemeBreakTest.txt CharWidths.txt unifont*.ttf unifont*.sfd
	rm -f utf8proc_data.c.new

=== debian/changelog ===
utf8proc (2.0.2-1mx15+1) mx; urgency=medium

  * Repackaged for MX-15/16.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 24 Feb 2019 19:19:23 -0800

utf8proc (2.0.2-1) unstable; urgency=medium

  * New upstream release

 -- Peter Colberg <peter@colberg.org>  Sat, 30 Jul 2016 23:21:18 -0400

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,19 @@
 Source: utf8proc
 Priority: optional
-Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
+Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
+XSBC-Original-Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
 Uploaders: Peter Colberg <peter@colberg.org>, Graham Inggs <ginggs@debian.org>
-Build-Depends: debhelper (>= 9), unicode-data (>= 6.1.0), perl
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 9),
+               perl,
+               unicode-data (<< 9.1),
+               unicode-data (>= 9.0)
+Standards-Version: 3.9.8
 Section: libs
 Homepage: http://julialang.org/utf8proc/
-Vcs-Git: git://anonscm.debian.org/pkg-julia/utf8proc.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-julia/utf8proc.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-julia/utf8proc.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-julia/utf8proc.git
 
-Package: libutf8proc1
+Package: libutf8proc2
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -25,7 +29,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libutf8proc1 (= ${binary:Version})
+Depends: libutf8proc2 (= ${binary:Version}), ${misc:Depends}
 Description: C library for processing UTF-8 Unicode data (development files)
  utf8proc is a small, clean C library that provides Unicode normalization,
  case-folding, and other operations for data in the UTF-8 encoding, supporting

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- prefix=/usr libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_installchangelogs:
	dh_installchangelogs NEWS.md

get-orig-source:
	uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-current-version

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## utf8proc 2.1.0

=== bench/Makefile ===
CURL=curl

CC = cc
CFLAGS = -O2 -std=c99 -pedantic -Wall

all: bench

LIBUTF8PROC = ../utf8proc.o

bench: bench.o util.o $(LIBUTF8PROC)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ bench.o util.o $(LIBUTF8PROC)

DATAURL = https://raw.githubusercontent.com/duerst/eprun/master/benchmark
DATAFILES = Deutsch_.txt Japanese_.txt Korean_.txt Vietnamese_.txt

$(DATAFILES):
	$(CURL) -O $(DATAURL)/$@

bench.out: $(DATAFILES) bench
	./bench -nfkc $(DATAFILES) > $@

# you may need make CPPFLAGS=... LDFLAGS=... to help it find ICU
icu: icu.o util.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ icu.o util.o -licuuc

icu.out: $(DATAFILES) icu
	./icu $(DATAFILES) > $@

unistring: unistring.o util.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ unistring.o util.o -lunistring

unistring.out: $(DATAFILES) unistring
	./unistring $(DATAFILES) > $@

.c.o:
	$(CC) $(CPPFLAGS) -I.. $(CFLAGS) -c -o $@ $<

clean:
	rm -rf *.o *.txt bench *.out icu unistring

=== debian/changelog ===
utf8proc (2.1.0-1) unstable; urgency=medium

  * New upstream release
  * Switch to unicode-data 10 (Closes: #867105)
  * Regenerate utf8proc_data.c from unicode-data 10 
  * Update debian/libutf8proc2.symbols
  * Switch to debhelper 10
  * Enable all hardening flags
  * Bump Standards-Version to 4.0.0
  * Update copyright, use https

 -- Graham Inggs <ginggs@debian.org>  Sat, 08 Jul 2017 10:47:15 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: utf8proc
 Priority: optional
-Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
-XSBC-Original-Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
+Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
 Uploaders: Peter Colberg <peter@colberg.org>, Graham Inggs <ginggs@debian.org>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                perl,
-               unicode-data (<< 9.1),
-               unicode-data (>= 9.0)
-Standards-Version: 3.9.8
+               unicode-data (<< 10.1),
+               unicode-data (>= 10.0)
+Standards-Version: 4.0.0
 Section: libs
-Homepage: http://julialang.org/utf8proc/
+Homepage: https://julialang.org/utf8proc/
 Vcs-Git: https://anonscm.debian.org/git/pkg-julia/utf8proc.git
 Vcs-Browser: https://anonscm.debian.org/git/pkg-julia/utf8proc.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- prefix=/usr libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_installchangelogs:
	dh_installchangelogs NEWS.md

get-orig-source:
	uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-current-version

## utf8proc 2.1.1

=== debian/changelog ===
utf8proc (2.1.1-1) unstable; urgency=medium

  [ Peter Colberg ]
  * Update Vcs-* fields for move to salsa.debian.org

  [ Graham Inggs ]
  * New upstream release (Closes: #902902)
  * Update upstream URLs for move to JuliaStrings
  * Refresh patches
  * Drop symbols of generated const tables, see upstream PR #100
  * Add Mo Zhou to uploaders
  * Switch to debhelper 11
  * Trim trailing whitespace from debian/changelog
  * Drop unnecessary get-orig-source target from debian/rules
  * Bump Standards-Version to 4.1.5
  * Switch to unicode-data 11 (Closes: #903381)
  * Regenerate utf8proc_data.c from unicode-data 11
  * Skip failing grapheme break tests

 -- Graham Inggs <ginggs@debian.org>  Mon, 09 Jul 2018 13:43:06 +0000

## utf8proc 2.2.0

=== debian/changelog ===
utf8proc (2.2.0-1) unstable; urgency=medium

  * New upstream release
  * Drop patches no longer needed, refresh remaining
  * Update debian/libutf8proc2.symbols
  * Update debian/copyright
  * New patch pass-hardening-flags.patch

 -- Graham Inggs <ginggs@debian.org>  Fri, 27 Jul 2018 10:17:12 +0000

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,18 @@
 Source: utf8proc
 Priority: optional
 Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
-Uploaders: Peter Colberg <peter@colberg.org>, Graham Inggs <ginggs@debian.org>
-Build-Depends: debhelper (>= 10),
+Uploaders: Peter Colberg <peter@colberg.org>,
+           Graham Inggs <ginggs@debian.org>,
+           Mo Zhou <cdluminate@gmail.com>,
+Build-Depends: debhelper (>= 11),
                perl,
-               unicode-data (<< 10.1),
-               unicode-data (>= 10.0)
-Standards-Version: 4.0.0
+               unicode-data (<< 11.1),
+               unicode-data (>= 11.0)
+Standards-Version: 4.1.5
 Section: libs
-Homepage: https://julialang.org/utf8proc/
-Vcs-Git: https://anonscm.debian.org/git/pkg-julia/utf8proc.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-julia/utf8proc.git
+Homepage: https://github.com/JuliaStrings/utf8proc
+Vcs-Git: https://salsa.debian.org/julia-team/utf8proc.git
+Vcs-Browser: https://salsa.debian.org/julia-team/utf8proc
 
 Package: libutf8proc2
 Architecture: any

## utf8proc 2.3.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

include (utils.cmake)

disallow_intree_builds()

project (utf8proc C)

# This is the ABI version number, which may differ from the
# API version number (defined in utf8proc.h).
# Be sure to also update these in Makefile and MANIFEST!
set(SO_MAJOR 2)
set(SO_MINOR 2)
set(SO_PATCH 0)

add_library (utf8proc
  utf8proc.c
  utf8proc.h
)

# expose header path, for when this is part of a larger cmake project
target_include_directories(utf8proc PUBLIC ../utf8proc)

if (BUILD_SHARED_LIBS)
  # Building shared library
else()
  # Building static library
  target_compile_definitions(utf8proc PUBLIC "UTF8PROC_STATIC")
  if (MSVC)
    set_target_properties(utf8proc PROPERTIES OUTPUT_NAME "utf8proc_static")
  endif()
endif()

target_compile_definitions(utf8proc PRIVATE "UTF8PROC_EXPORTS")

if (NOT MSVC)
  set_target_properties(
    utf8proc PROPERTIES
    COMPILE_FLAGS "-O2 -std=c99 -pedantic -Wall"
  )
endif ()

set_target_properties (utf8proc PROPERTIES
  POSITION_INDEPENDENT_CODE ON
  VERSION "${SO_MAJOR}.${SO_MINOR}.${SO_PATCH}"
  SOVERSION ${SO_MAJOR}
)

install(TARGETS utf8proc
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)

install(
  FILES
    "${PROJECT_SOURCE_DIR}/utf8proc.h"
  DESTINATION include)

=== Makefile ===
--- 
+++ 
@@ -1,18 +1,18 @@
 # libutf8proc Makefile
 
 # programs
-MAKE=make
 AR?=ar
 CC?=gcc
 INSTALL=install
 FIND=find
+PERL=perl
 
 # compiler settings
 CFLAGS ?= -O2
 PICFLAG = -fPIC
 C99FLAG = -std=c99
 WCFLAGS = -Wall -pedantic
-UCFLAGS = $(CFLAGS) $(PICFLAG) $(C99FLAG) $(WCFLAGS) -DUTF8PROC_EXPORTS
+UCFLAGS = $(CPPFLAGS) $(CFLAGS) $(PICFLAG) $(C99FLAG) $(WCFLAGS) -DUTF8PROC_EXPORTS $(UTF8PROC_DEFINES)
 
 # shared-library version MAJOR.MINOR.PATCH ... this may be *different*
 # from the utf8proc version number because it indicates ABI compatibility,
@@ -21,8 +21,8 @@
 # The API version number is defined in utf8proc.h.
 # Be sure to also update these ABI versions in MANIFEST and CMakeLists.txt!
 MAJOR=2
-MINOR=0
-PATCH=2
+MINOR=2
+PATCH=0
 
 OS := $(shell uname)
 ifeq ($(OS),Darwin) # MacOS X
@@ -37,6 +37,10 @@
 prefix=/usr/local
 libdir=$(prefix)/lib
 includedir=$(prefix)/include
+pkgconfigdir=$(libdir)/pkgconfig
+
+pkglibdir=$(libdir:$(prefix)/%=%)
+pkgincludedir=$(includedir:$(prefix)/%=%)
 
 # meta targets
 
@@ -46,10 +50,11 @@
 
 clean:
 	rm -f utf8proc.o libutf8proc.a libutf8proc.$(SHLIB_VERS_EXT) libutf8proc.$(SHLIB_EXT)
+	rm -f libutf8proc.pc
 ifneq ($(OS),Darwin)
 	rm -f libutf8proc.so.$(MAJOR)
 endif
-	rm -f test/tests.o test/normtest test/graphemetest test/printproperty test/charwidth test/valid test/iterate test/case
+	rm -f test/tests.o test/normtest test/graphemetest test/printproperty test/charwidth test/valid test/iterate test/case test/custom test/misc
 	rm -rf MANIFEST.new tmp
 	$(MAKE) -C bench clean
 	$(MAKE) -C data clean
@@ -82,17 +87,27 @@
 	ln -f -s libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH) $@.$(MAJOR)
 
 libutf8proc.$(MAJOR).dylib: utf8proc.o
-	$(CC) -dynamiclib -o $@ $^ -install_name $(libdir)/$@ -Wl,-compatibility_version -Wl,$(MAJOR) -Wl,-current_version -Wl,$(MAJOR).$(MINOR).$(PATCH)
+	$(CC) $(LDFLAGS) -dynamiclib -o $@ $^ -install_name $(libdir)/$@ -Wl,-compatibility_version -Wl,$(MAJOR) -Wl,-current_version -Wl,$(MAJOR).$(MINOR).$(PATCH)
 
 libutf8proc.dylib: libutf8proc.$(MAJOR).dylib
 	ln -f -s libutf8proc.$(MAJOR).dylib $@
 
-install: libutf8proc.a libutf8proc.$(SHLIB_EXT) libutf8proc.$(SHLIB_VERS_EXT)
+libutf8proc.pc: libutf8proc.pc.in
+	sed \
+		-e 's#PREFIX#$(prefix)#' \
+		-e 's#LIBDIR#$(pkglibdir)#' \
+		-e 's#INCLUDEDIR#$(pkgincludedir)#' \
+		-e 's#VERSION#$(MAJOR).$(MINOR).$(PATCH)#' \
+		libutf8proc.pc.in > libutf8proc.pc
+
+install: libutf8proc.a libutf8proc.$(SHLIB_EXT) libutf8proc.$(SHLIB_VERS_EXT) libutf8proc.pc
 	mkdir -m 755 -p $(DESTDIR)$(includedir)
 	$(INSTALL) -m 644 utf8proc.h $(DESTDIR)$(includedir)
 	mkdir -m 755 -p $(DESTDIR)$(libdir)
 	$(INSTALL) -m 644 libutf8proc.a $(DESTDIR)$(libdir)
 	$(INSTALL) -m 755 libutf8proc.$(SHLIB_VERS_EXT) $(DESTDIR)$(libdir)
+	mkdir -m 755 -p $(DESTDIR)$(pkgconfigdir)
+	$(INSTALL) -m 644 libutf8proc.pc $(DESTDIR)$(pkgconfigdir)/libutf8proc.pc
 	ln -f -s libutf8proc.$(SHLIB_VERS_EXT) $(DESTDIR)$(libdir)/libutf8proc.$(SHLIB_EXT)
 ifneq ($(OS),Darwin)
 	ln -f -s libutf8proc.$(SHLIB_VERS_EXT) $(DESTDIR)$(libdir)/libutf8proc.so.$(MAJOR)
@@ -116,31 +131,39 @@
 	$(CC) $(UCFLAGS) -c -o test/tests.o test/tests.c
 
 test/normtest: test/normtest.c test/tests.o utf8proc.o utf8proc.h test/tests.h
-	$(CC) $(UCFLAGS) test/normtest.c test/tests.o utf8proc.o -o $@
+	$(CC) $(UCFLAGS) $(LDFLAGS) test/normtest.c test/tests.o utf8proc.o -o $@
 
 test/graphemetest: test/graphemetest.c test/tests.o utf8proc.o utf8proc.h test/tests.h
-	$(CC) $(UCFLAGS) test/graphemetest.c test/tests.o utf8proc.o -o $@
+	$(CC) $(UCFLAGS) $(LDFLAGS) test/graphemetest.c test/tests.o utf8proc.o -o $@
 
 test/printproperty: test/printproperty.c test/tests.o utf8proc.o utf8proc.h test/tests.h
-	$(CC) $(UCFLAGS) test/printproperty.c test/tests.o utf8proc.o -o $@
+	$(CC) $(UCFLAGS) $(LDFLAGS) test/printproperty.c test/tests.o utf8proc.o -o $@
 
 test/charwidth: test/charwidth.c test/tests.o utf8proc.o utf8proc.h test/tests.h
-	$(CC) $(UCFLAGS) test/charwidth.c test/tests.o utf8proc.o -o $@
+	$(CC) $(UCFLAGS) $(LDFLAGS) test/charwidth.c test/tests.o utf8proc.o -o $@
 
 test/valid: test/valid.c test/tests.o utf8proc.o utf8proc.h test/tests.h
-	$(CC) $(UCFLAGS) test/valid.c test/tests.o utf8proc.o -o $@
+	$(CC) $(UCFLAGS) $(LDFLAGS) test/valid.c test/tests.o utf8proc.o -o $@
 
 test/iterate: test/iterate.c test/tests.o utf8proc.o utf8proc.h test/tests.h
-	$(CC) $(UCFLAGS) test/iterate.c test/tests.o utf8proc.o -o $@
+	$(CC) $(UCFLAGS) $(LDFLAGS) test/iterate.c test/tests.o utf8proc.o -o $@
 
 test/case: test/case.c test/tests.o utf8proc.o utf8proc.h test/tests.h
-	$(CC) $(UCFLAGS) test/case.c test/tests.o utf8proc.o -o $@
+	$(CC) $(UCFLAGS) $(LDFLAGS) test/case.c test/tests.o utf8proc.o -o $@
 
-check: test/normtest data/NormalizationTest.txt test/graphemetest data/GraphemeBreakTest.txt test/printproperty test/case test/charwidth test/valid test/iterate bench/bench.c bench/util.c bench/util.h utf8proc.o
+test/custom: test/custom.c test/tests.o utf8proc.o utf8proc.h test/tests.h
+	$(CC) $(UCFLAGS) $(LDFLAGS) test/custom.c test/tests.o utf8proc.o -o $@
+
+test/misc: test/misc.c test/tests.o utf8proc.o utf8proc.h test/tests.h
+	$(CC) $(UCFLAGS) $(LDFLAGS) -DUNICODE_VERSION='"'`$(PERL) -ne "/^UNICODE_VERSION=/ and print $$';" data/Makefile`'"' test/misc.c test/tests.o utf8proc.o -o $@
+
+check: test/normtest data/NormalizationTest.txt test/graphemetest data/GraphemeBreakTest.txt test/printproperty test/case test/custom test/charwidth test/misc test/valid test/iterate bench/bench.c bench/util.c bench/util.h utf8proc.o
 	$(MAKE) -C bench
 	test/normtest data/NormalizationTest.txt
 	test/graphemetest data/GraphemeBreakTest.txt
 	test/charwidth
+	test/misc
 	test/valid
 	test/iterate
 	test/case
+	test/custom

=== data/Makefile ===
# Unicode data generation rules.  Except for the test data files, most
# users will not use these Makefile rules, which are primarily to re-generate
# unicode_data.c when we get a new Unicode version or charwidth data; they
# require ruby and julia to be installed.

# programs
CURL=curl
RUBY=ruby
PERL=perl
MAKE=make
JULIA=julia
CURLFLAGS = --retry 5 --location

.PHONY: clean

.DELETE_ON_ERROR:

utf8proc_data.c.new: data_generator.rb UnicodeData.txt GraphemeBreakProperty.txt DerivedCoreProperties.txt CompositionExclusions.txt CaseFolding.txt CharWidths.txt emoji-data.txt
	$(RUBY) data_generator.rb < UnicodeData.txt > $@

CharWidths.txt: charwidths.jl EastAsianWidth.txt
	$(JULIA) charwidths.jl > $@

# Unicode data version (must also update utf8proc_unicode_version function)
UNICODE_VERSION=12.0.0

UnicodeData.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/UnicodeData.txt

EastAsianWidth.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/EastAsianWidth.txt

GraphemeBreakProperty.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/auxiliary/GraphemeBreakProperty.txt

DerivedCoreProperties.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/DerivedCoreProperties.txt

CompositionExclusions.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/CompositionExclusions.txt

CaseFolding.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/CaseFolding.txt

NormalizationTest.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/NormalizationTest.txt

GraphemeBreakTest.txt:
	$(CURL) $(CURLFLAGS) $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/auxiliary/GraphemeBreakTest.txt | $(PERL) -pe 's,÷,/,g;s,×,+,g' > $@

emoji-data.txt:
	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://unicode.org/Public/emoji/`echo $(UNICODE_VERSION) | cut -d. -f1-2`/emoji-data.txt

clean:
	rm -f UnicodeData.txt EastAsianWidth.txt GraphemeBreakProperty.txt DerivedCoreProperties.txt CompositionExclusions.txt CaseFolding.txt NormalizationTest.txt GraphemeBreakTest.txt CharWidths.txt emoji-data.txt
	rm -f utf8proc_data.c.new

=== debian/changelog ===
utf8proc (2.3.0-1) unstable; urgency=medium

  * New upstream version 2.3.0 (Closes: #927941)
  * Bump unicode-data requirement to (>= 12.1) && (<< 12.2).
  * Refresh use-unicode-data.patch; Remove pass-hardening-flags.patch (merged).
  * Patch: update utf8proc_data.c against unicode-data 12.1.0~pre1.
  * Patch: update unicode-data version strings to 12.1.0
  * Patch: upstream didn't bump minor version in build system and header.
  * Install the newly-added pkgconfig file. (Closes: #927260)
  * Add a new symbol.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 27 Apr 2019 08:12:00 +0000

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
            Mo Zhou <cdluminate@gmail.com>,
 Build-Depends: debhelper (>= 11),
                perl,
-               unicode-data (<< 11.1),
-               unicode-data (>= 11.0)
+               unicode-data (<< 12.2),
+               unicode-data (>= 12.1)
 Standards-Version: 4.1.5
 Section: libs
 Homepage: https://github.com/JuliaStrings/utf8proc

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- prefix=/usr libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
	install -Dm0644 libutf8proc.pc debian/libutf8proc-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libutf8proc.pc

override_dh_installchangelogs:
	dh_installchangelogs NEWS.md

## utf8proc 2.4.0

=== debian/changelog ===
utf8proc (2.4.0-2build2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 11:20:52 +0000

utf8proc (2.4.0-2build1) focal; urgency=medium

  * No-change rebuild to restore i386 binaries

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 13 Jan 2020 02:00:33 +0000

utf8proc (2.4.0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set upstream metadata fields:
    Bug-Database, Repository, Repository-Browse.
  * Update standards version to 4.4.1, no changes needed.

  [ Mo Zhou ]
  * Update my mail address in control and copyright.
  * Initialize autopkgtest: compile and run upstream tests.

 -- Mo Zhou <lumin@debian.org>  Tue, 07 Jan 2020 14:56:30 +0800

utf8proc (2.4.0-1) unstable; urgency=medium

  * New upstream version 2.4.0
  * Bump Standards-Version to 4.4.0 (no change).
  * Delete d/compat in favor of debhelper-compat (= 11).
  * Update patches:
    * Rebase use-unicode-data.patch
    - Remove unicode-data-12.1.0pre1.patch
    - Remove utf8proc-unicode-version.patch

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 21 Aug 2019 14:41:53 +0000

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
 Uploaders: Peter Colberg <peter@colberg.org>,
            Graham Inggs <ginggs@debian.org>,
-           Mo Zhou <cdluminate@gmail.com>,
-Build-Depends: debhelper (>= 11),
+           Mo Zhou <lumin@debian.org>
+Build-Depends: debhelper-compat (= 12),
                perl,
                unicode-data (<< 12.2),
                unicode-data (>= 12.1)
-Standards-Version: 4.1.5
+Standards-Version: 4.4.1
 Section: libs
 Homepage: https://github.com/JuliaStrings/utf8proc
 Vcs-Git: https://salsa.debian.org/julia-team/utf8proc.git

## utf8proc 2.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,8 +10,11 @@
 # API version number (defined in utf8proc.h).
 # Be sure to also update these in Makefile and MANIFEST!
 set(SO_MAJOR 2)
-set(SO_MINOR 2)
-set(SO_PATCH 0)
+set(SO_MINOR 3)
+set(SO_PATCH 2)
+
+option(UTF8PROC_INSTALL "Enable installation of utf8proc" On)
+option(UTF8PROC_ENABLE_TESTING "Enable testing of utf8proc" Off)
 
 add_library (utf8proc
   utf8proc.c
@@ -46,12 +49,48 @@
   SOVERSION ${SO_MAJOR}
 )
 
-install(TARGETS utf8proc
-  RUNTIME DESTINATION bin
-  LIBRARY DESTINATION lib
-  ARCHIVE DESTINATION lib)
+if (UTF8PROC_INSTALL)
+  install(TARGETS utf8proc
+    RUNTIME DESTINATION bin
+    LIBRARY DESTINATION lib
+    ARCHIVE DESTINATION lib)
 
-install(
-  FILES
-    "${PROJECT_SOURCE_DIR}/utf8proc.h"
-  DESTINATION include)
+  install(
+    FILES
+      "${PROJECT_SOURCE_DIR}/utf8proc.h"
+    DESTINATION include)
+endif()
+
+if(UTF8PROC_ENABLE_TESTING)
+  enable_testing()
+  add_executable(case test/tests.h test/tests.c utf8proc.h test/case.c)
+  target_link_libraries(case utf8proc)
+  add_executable(custom test/tests.h test/tests.c utf8proc.h test/custom.c)
+  target_link_libraries(custom utf8proc)
+  add_executable(iterate test/tests.h test/tests.c utf8proc.h test/iterate.c)
+  target_link_libraries(iterate utf8proc)
+  add_executable(misc test/tests.h test/tests.c utf8proc.h test/misc.c)
+  target_link_libraries(misc utf8proc)
+  add_executable(printproperty test/tests.h test/tests.c utf8proc.h test/printproperty.c)
+  target_link_libraries(printproperty utf8proc)
+  add_executable(valid test/tests.h test/tests.c utf8proc.h test/valid.c)
+  target_link_libraries(valid utf8proc)
+  add_test(testcase case)
+  add_test(testcustom custom)
+  add_test(testiterate iterate)
+  add_test(testmisc misc)
+  add_test(testprintproperty printproperty)
+  add_test(testvalid valid)
+  if (NOT WIN32)
+    # Some test disabled, because they don't compile on Windows, missing getline, ...
+    add_executable(charwidth test/tests.h test/tests.c utf8proc.h test/charwidth.c)
+    target_link_libraries(charwidth utf8proc)
+    add_executable(graphemetest test/tests.h test/tests.c utf8proc.h test/graphemetest.c)
+    target_link_libraries(graphemetest utf8proc)
+    add_executable(normtest test/tests.h test/tests.c utf8proc.h test/normtest.c)
+    target_link_libraries(normtest utf8proc)
+    add_test(testcharwidth charwidth)
+    #add_test(testgraphemetest graphemetest data/GraphemeBreakTest.txt)
+    #add_test(testnormtest normtest data/NormalizationTest.txt)
+  endif()
+endif()

=== Makefile ===
--- 
+++ 
@@ -13,6 +13,8 @@
 C99FLAG = -std=c99
 WCFLAGS = -Wall -pedantic
 UCFLAGS = $(CPPFLAGS) $(CFLAGS) $(PICFLAG) $(C99FLAG) $(WCFLAGS) -DUTF8PROC_EXPORTS $(UTF8PROC_DEFINES)
+LDFLAG_SHARED = -shared
+SOFLAG = -Wl,-soname
 
 # shared-library version MAJOR.MINOR.PATCH ... this may be *different*
 # from the utf8proc version number because it indicates ABI compatibility,
@@ -21,8 +23,8 @@
 # The API version number is defined in utf8proc.h.
 # Be sure to also update these ABI versions in MANIFEST and CMakeLists.txt!
 MAJOR=2
-MINOR=2
-PATCH=0
+MINOR=3
+PATCH=2
 
 OS := $(shell uname)
 ifeq ($(OS),Darwin) # MacOS X
@@ -79,7 +81,7 @@
 	$(AR) rs libutf8proc.a utf8proc.o
 
 libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH): utf8proc.o
-	$(CC) $(LDFLAGS) -shared -o $@ -Wl,-soname -Wl,libutf8proc.so.$(MAJOR) utf8proc.o
+	$(CC) $(LDFLAGS) $(LDFLAG_SHARED) -o $@ $(SOFLAG) -Wl,libutf8proc.so.$(MAJOR) utf8proc.o
 	chmod a-x $@
 
 libutf8proc.so: libutf8proc.so.$(MAJOR).$(MINOR).$(PATCH)

=== data/Makefile ===
--- 
+++ 
@@ -22,7 +22,7 @@
 	$(JULIA) charwidths.jl > $@
 
 # Unicode data version (must also update utf8proc_unicode_version function)
-UNICODE_VERSION=12.0.0
+UNICODE_VERSION=13.0.0
 
 UnicodeData.txt:
 	$(CURL) $(CURLFLAGS) -o $@ -O http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/UnicodeData.txt
@@ -49,7 +49,7 @@
 	$(CURL) $(CURLFLAGS) $(URLCACHE)http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/auxiliary/GraphemeBreakTest.txt | $(PERL) -pe 's,÷,/,g;s,×,+,g' > $@
 
 emoji-data.txt:
-	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://unicode.org/Public/emoji/`echo $(UNICODE_VERSION) | cut -d. -f1-2`/emoji-data.txt
+	$(CURL) $(CURLFLAGS) -o $@ -O $(URLCACHE)http://unicode.org/Public/$(UNICODE_VERSION)/ucd/emoji/emoji-data.txt
 
 clean:
 	rm -f UnicodeData.txt EastAsianWidth.txt GraphemeBreakProperty.txt DerivedCoreProperties.txt CompositionExclusions.txt CaseFolding.txt NormalizationTest.txt GraphemeBreakTest.txt CharWidths.txt emoji-data.txt

=== debian/changelog ===
utf8proc (2.5.0-1) unstable; urgency=medium

  * New upstream release
  * Refresh use-unicode-data.patch
  * Build with unicode-data 13.0 (Closes: #954131)
  * Set Rules-Requires-Root: no
  * Add Build-Depends-Package to libutf8proc2.symbols
  * Bump Standards-Version to 4.5.0, no changes

 -- Graham Inggs <ginggs@debian.org>  Mon, 30 Mar 2020 08:12:49 +0000

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,10 @@
            Mo Zhou <lumin@debian.org>
 Build-Depends: debhelper-compat (= 12),
                perl,
-               unicode-data (<< 12.2),
-               unicode-data (>= 12.1)
-Standards-Version: 4.4.1
+               unicode-data (<< 13.1),
+               unicode-data (>= 13.0)
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Section: libs
 Homepage: https://github.com/JuliaStrings/utf8proc
 Vcs-Git: https://salsa.debian.org/julia-team/utf8proc.git

=== debian/tests/control ===
Test-Command: make -f debian/tests/Makefile
Depends: @, build-essential
Restrictions: allow-stderr
